﻿using Sintesi.CashFund.Domain;
using Sintesi.CashFund.Domain.Models;
using Sintesi.CashFund.WebUI.Models;
using Sintesi.CashFund.Domain.Concrete;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.EJ.Export;
using System.Data.Entity.SqlServer;
using Syncfusion.XlsIO;
using Syncfusion.Pdf;
using System.Drawing;
using Syncfusion.Pdf.Graphics;

namespace Sintesi.CashFund.WebUI.Report
{
    public partial class ReportOspiti : System.Web.UI.Page
    {
        private edmCashFund edm = new edmCashFund();
        List<TipoVisualizzazione> listVisual = new List<TipoVisualizzazione>();
        List<ReportSaldoReparto> lista = new List<ReportSaldoReparto>();
        double? SaldoIniziale = new int();
        double? SaldoFinale = new int();
        public class Reparti
        {
            public string RepartoId { get; set; }
            public string Nome { get; set; }
        }
        public class TipoVisualizzazione
        {
            public int TipoId { get; set; }
            public string Tipo { get; set; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session[Globals.DIRITTI] != null)
            {
                if (Session[Globals.DIRITTI] != null && (((int)Session[Globals.DIRITTI]) == (int)RuoliUtenti.Amministratore) || (((int)Session[Globals.DIRITTI]) == (int)RuoliUtenti.Responsabile))
                {

                    setddlReparti();
                    SetddlTipoVisualizzazione();
                    SetVisibleGrid();
                    if (!IsPostBack)
                    {

                        if (this.ddReparti.SelectedItemsValue.Count() == 0)
                        {
                            this.ddReparti.SelectedIndex = 0;
                        }
                        if (this.dtpInizio.Value == null)
                        {
                            this.dtpInizio.Value = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1);
                        }
                        if (this.dtpFine.Value == null)
                        {
                            this.dtpFine.Value = DateTime.Now;
                        }
                        if (this.ddTipoReport.SelectedItemsValue.Count() == 0)
                        {
                            this.ddTipoReport.SelectedIndex = 0;
                        }

                        setGridField((string)this.ddReparti.Value, (DateTime)this.dtpInizio.Value, (DateTime)this.dtpFine.Value);
                    }
                }
                else
                {
                    Response.Redirect("~/Autorizzazioni/AccessoNegato.aspx");
                }
            }
            else
            {
                Response.Redirect("~/Autorizzazioni/AccessoNegato.aspx");
            }
        }

        protected void SetVisibleGrid()
        {
            string report = this.ddTipoReport.Value;
            if (report == Convert.ToString((int)TipoVisualizzazioneGrid.Movimenti))
            {
                this.ReportSaldoGrid.Visible = false;
                this.ReportMovimentiGrid.Visible = true;
            }
            else
            {
                this.ReportSaldoGrid.Visible = true;
                this.ReportMovimentiGrid.Visible = false;
            }
        }


        protected void btnCerca_Click(object sender, EventArgs e)
        {
            DateTime datainiziale = Convert.ToDateTime(this.dtpInizio.Value);
            DateTime datafinale = Convert.ToDateTime(this.dtpFine.Value);
            string idReparto = this.ddReparti.Value;
            string report = this.ddTipoReport.Value;
            if (report == Convert.ToString((int)TipoVisualizzazioneGrid.Movimenti))
            {
                this.ReportSaldoGrid.Visible = false;
                this.ReportMovimentiGrid.Visible = true;
            }
            else
            {
                this.ReportSaldoGrid.Visible = true;
                this.ReportMovimentiGrid.Visible = false;
            }
            //SetSaldi(idReparto,datainiziale,datafinale);
            setGridField(idReparto, datainiziale, datafinale);
        }

        protected void setddlReparti()
        {
            if ((((int)Session[Globals.DIRITTI]) == (int)RuoliUtenti.Amministratore))
            {
                var dataset = edm.View_Reparti
                    .Select(x => new Reparti
                    {
                        RepartoId = x.ID_Reparto,
                        Nome = x.Des_Reparto
                    }).ToList();
                ddReparti.DataSource = dataset;
            }
            else
            {
                int IdUser = (int)Session[Globals.UTENTE_ID];
                List<string> RepartiID = (from d in edm.Reparti_Utenti
                                          where d.UtenteId == IdUser
                                          select d.RepartoId).ToList();
                List<View_Reparti> listareparti = (from a in edm.View_Reparti
                                                   select a).ToList();
                List<View_Reparti> list = new List<View_Reparti>();
                int i = 0;
                foreach (var y in listareparti)
                {
                    if (y.ID_Reparto == RepartiID[i])
                    {
                        list.Add(y);
                        i++;
                    }

                }
                var dataset = list
                  .Select(x => new Reparti
                  {
                      RepartoId = x.ID_Reparto,
                      Nome = x.Des_Reparto
                  }).ToList();
                ddReparti.DataSource = dataset;
            }
        }

        //inizializzo la dropdown per il tipo di visualizzazione
        protected void SetddlTipoVisualizzazione()
        {
            listVisual.Add(new TipoVisualizzazione
            {
                TipoId = 0,
                Tipo = "Saldo"
            });
            listVisual.Add(new TipoVisualizzazione
            {
                TipoId = 1,
                Tipo = "Movimenti"
            });
            ddTipoReport.DataSource = listVisual;
        }
        protected void SetSaldi(string RepartoID, DateTime datainiziale, DateTime datafinale, string IdOspite)
        {
            double? SaldoInizialeMovimentiReparto, SaldoFinaleMovimentiReparto, SaldoInizialeMovimentiOspiti, SaldoFinaleMovimentiOspiti;
            //somma movimenti iniziali per reparto dell'ospite
            SaldoInizialeMovimentiReparto = (from c in edm.MovimentiReparto
                                             where c.RepartoId == RepartoID && c.ScaricoCassa == true && c.DataOperazione < datainiziale && c.Ospite == IdOspite
                                             select c.Importo).Sum() ?? 0;
            //somma movimenti finali per reparto dell'ospite
            SaldoFinaleMovimentiReparto = (from d in edm.MovimentiReparto
                                           where d.RepartoId == RepartoID && d.ScaricoCassa == true && d.DataOperazione <= datafinale
                                           && d.Ospite == IdOspite
                                           select d.Importo).Sum() ?? 0;
            //somma movimenti iniziali per conto dell'ospite
            SaldoInizialeMovimentiOspiti = (from c in edm.MovimentiContoOspiti
                                            where c.Ospite == IdOspite && c.CreatoIl < datainiziale
                                            select c.Importo).Sum() ?? 0;
            //somma movimenti finali per conto  dell'ospite
            SaldoFinaleMovimentiOspiti = (from d in edm.MovimentiContoOspiti
                                          where d.CreatoIl <= datafinale
                                          && d.Ospite == IdOspite
                                          select d.Importo).Sum() ?? 0;
            //somma delle somme iniziali 
            SaldoIniziale = SaldoInizialeMovimentiReparto + SaldoInizialeMovimentiOspiti;
            //somma delle somme finali
            SaldoFinale = SaldoFinaleMovimentiReparto + SaldoFinaleMovimentiOspiti;
        }

        protected void setGridField(string idReparto, DateTime datainiziale, DateTime datafinale)
        {

            List<View_Ospiti> ospiti = new List<View_Ospiti>();
            View_Ospiti ospite;
            OspitiRepository ospitiRepo = new OspitiRepository();
            //lista di ospiti ancora presenti nel reparto indicato
            ospiti = (from a in edm.View_Ospiti
                      where (a.Dt_Uscita == null || a.Dt_Uscita > DateTime.Now) && a.ID_Reparto == idReparto
                      select a).ToList();

            //ottengo descrizione del reparto da IdReparto
            string reparto = (from t in edm.View_Reparti
                              where t.ID_Reparto == idReparto
                              select t.Des_Reparto).FirstOrDefault();
            if (this.ddTipoReport.Value == Convert.ToString((int)TipoVisualizzazioneGrid.Saldo))
            {

                ReportSaldoReparto reportSaldo;
                //scorro la lista di ospiti e metto nella lista di tipo ReportSaldoReparto
                for (int i = 0; i < ospiti.Count(); i++)
                {
                    //ottengo i saldi dell'ospite 
                    SetSaldi(idReparto, datainiziale, datafinale, ospiti[i].ID_Ospite);
                    //inizializzo variabile ti tipo reportSaldoReparto
                    reportSaldo = new ReportSaldoReparto();
                    reportSaldo.Ospite = ospiti[i].Nome + " " + ospiti[i].Cognome;
                    reportSaldo.Reparto = reparto;
                    reportSaldo.DataFine = datafinale;
                    reportSaldo.DataInizio = datainiziale;
                    reportSaldo.SaldoFinale = SaldoFinale;
                    reportSaldo.SaldoIniziale = SaldoIniziale;
                    lista.Add(reportSaldo);
                }
                this.ReportSaldoGrid.DataSource = lista;
                this.ReportSaldoGrid.DataBind();
            }
            //se il report è per movimenti
            else
            {

                List<MovimentiReparto> listaMovimentiReparto = new List<MovimentiReparto>();
                List<MovimentiContoOspiti> listaMovimentoContoOsp = new List<MovimentiContoOspiti>();
                //utilizzo una lista di tipo viewmodel per unire in visualizzazione movimenti per conto e per reparto 
                List<MovimentiContoViewModels> listMovimentiOspite = new List<MovimentiContoViewModels>();
                //scorro gli ospiti per visualizzare tutti i suoi movimenti
                for (int i = 0; i < ospiti.Count(); i++)
                {

                    MovimentiContoViewModels movimentoOspite;
                    //metto in una lista tutti i movimenti dell'ospite per movimenti reparto
                    edm.MovimentiReparto.Include("Causali").ToList();
                    edm.MovimentiReparto.Include("TipiMovimento").ToList();
                    string idOspite = ospiti[i].ID_Ospite;
                    try
                    {
                        listaMovimentiReparto = (from a in edm.MovimentiReparto
                                                 where a.RepartoId == idReparto && a.DataOperazione >= datainiziale && a.DataOperazione <= datafinale && a.Ospite == idOspite
                                                 select a).ToList();

                    }
                    catch (Exception ex)
                    {
                        throw ex;
                    }
                    foreach (var a in listaMovimentiReparto)
                    {
                        movimentoOspite = new MovimentiContoViewModels();
                        movimentoOspite.Progressivo = a.Progressivo;
                        ospite = ospitiRepo.GetOspite(a.Ospite);
                        if (ospite != null)
                            movimentoOspite.Ospite = ospite.Cognome + " " + ospite.Nome;
                        movimentoOspite.Importo = a.Importo ?? 0;
                        movimentoOspite.DataOperazione = a.DataOperazione;
                        movimentoOspite.DataRegistrazione = a.DataRegistrazione;
                        movimentoOspite.Annotazioni = a.Annotazioni;
                        movimentoOspite.Descrizione = a.Descrizione;
                        movimentoOspite.CausaleId = a.CausaleId;
                        movimentoOspite.ContoId = a.ContoId ?? 0;
                        movimentoOspite.TipoMovimentoId = a.TipoMovimentoId;
                        listMovimentiOspite.Add(movimentoOspite);
                    }
                    //ottengo tutti i movimenti per conto ospiti
                    edm.MovimentiContoOspiti.Include("MovimentiConto").ToList();
                    listaMovimentoContoOsp = (from q in edm.MovimentiContoOspiti
                                              where q.MovimentiConto.DataOperazione >= datainiziale && q.MovimentiConto.DataOperazione <= datafinale && q.Ospite == idOspite
                                              select q).ToList();
                    foreach (var a in listaMovimentoContoOsp)
                    {
                        movimentoOspite = new MovimentiContoViewModels();
                        movimentoOspite.MovimentoContoOspiteId = a.MovimentoContoOspiteId;
                        movimentoOspite.Progressivo = a.MovimentiConto.Progressivo;
                        ospite = ospitiRepo.GetOspite(a.Ospite);
                        if (ospite != null)
                            movimentoOspite.Ospite = ospite.Cognome + " " + ospite.Nome;
                        movimentoOspite.Importo = a.Importo ?? 0;
                        movimentoOspite.DataOperazione = a.MovimentiConto.DataOperazione;
                        movimentoOspite.DataRegistrazione = a.MovimentiConto.DataRegistrazione;
                        movimentoOspite.Annotazioni = a.MovimentiConto.Annotazioni;
                        movimentoOspite.Descrizione = a.MovimentiConto.Descrizione;
                        listMovimentiOspite.Add(movimentoOspite);
                    }
                }

                //tramite listItems associo alle colonne indicate il valore da visualizzare
                List<GenericListItem> listC = (from a in edm.Causali
                                               select new GenericListItem { text = a.Nome, value = SqlFunctions.StringConvert((double)a.CausaleId).Trim() }).ToList();
                List<GenericListItem> listTipiMov = (from f in edm.TipiMovimento
                                                     select new GenericListItem { text = f.Nome, value = SqlFunctions.StringConvert((double)f.TipoMovimentoId).Trim() }).ToList();

                //ListItem OspitiList = new ListItem();
                //List<GenericListItem> list = (from a in edm.View_Ospiti
                //                              where a.Dt_Uscita == null && a.ID_Reparto == idReparto
                //                              orderby a.Cognome, a.Nome
                //                              select new GenericListItem { text = a.Cognome + " " + a.Nome, value = a.ID_Ospite }).ToList();
                //var indexc = this.ReportMovimentiGrid.Columns.FindIndex(col => col.Field == "Ospite");
                //this.ReportMovimentiGrid.Columns.ElementAt(indexc).DataSource = list;
                var indexCausale = this.ReportMovimentiGrid.Columns.FindIndex(col => col.Field == "CausaleId");
                this.ReportMovimentiGrid.Columns.ElementAt(indexCausale).DataSource = listC;
                var index = this.ReportMovimentiGrid.Columns.FindIndex(col => col.Field == "TipoMovimentoId");
                this.ReportMovimentiGrid.Columns.ElementAt(index).DataSource = listTipiMov;
                //passo la lista ottenuta alla sorgente dati della grid
                this.ReportMovimentiGrid.DataSource = listMovimentiOspite;
                this.ReportMovimentiGrid.DataBind();
            }
        }

        //con la selezione del reparto dalla dropdown setto i campi della grid
        protected void ddReparti_ValueSelect(object sender, Syncfusion.JavaScript.Web.DropdownListEventArgs e)
        {
            setGridField((string)this.ddReparti.Value, (DateTime)this.dtpInizio.Value, (DateTime)this.dtpFine.Value);
        }
        //esportazione grid in pdf grid per il saldo
        protected void ReportSaldoGrid_ServerPdfExporting(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            btnCerca_Click(sender, e);
            PdfExport exp = new PdfExport();
            PdfDocument pdfdocument = exp.Export(ReportSaldoGrid.Model, (IEnumerable)ReportSaldoGrid.DataSource, "ReportOspitiSaldo.pdf", false, false, "flat-lime", true,true);
            RectangleF rect = new RectangleF(0, 0, pdfdocument.PageSettings.Width, 50);

            //create a header pager template
            PdfPageTemplateElement header = new PdfPageTemplateElement(rect);

            Font f = new Font("Helvetica", 10, FontStyle.Bold);

            PdfFont font = new PdfTrueTypeFont(f, true);

            header.Graphics.DrawString("Report Saldo Ospiti reparto " + GetNomeReparto()  + " dal " + (dtpInizio.Value ?? DateTime.MinValue).ToString("dd/MM/yyyy") + " al " + (dtpFine.Value ?? DateTime.MinValue).ToString("dd/MM/yyyy"), font, PdfBrushes.Black, new Point(250, 0)); //Add custom text to the Header
            pdfdocument.Template.Top = header; //Append custom template to the document   

            pdfdocument.Save("ReportOspitiSaldo.pdf", Response, HttpReadType.Save);
            
        }
        //esportazione grid in excel per il saldo
        protected void ReportSaldoGrid_ServerExcelExporting(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            
            btnCerca_Click(sender, e);
            ExcelExport exp = new ExcelExport();

            IWorkbook book = exp.Export(ReportSaldoGrid.Model, (IEnumerable)ReportSaldoGrid.DataSource, "ReportOspitiSaldo.xlsx", ExcelVersion.Excel2010, false, false, "flat-lime", true);
            
            book.ActiveSheet.InsertRow(1);
            // Merging the sheet from Range A1 to E1 for adding title space
            book.ActiveSheet.Range["A1:E1"].Merge();

            //Adding the title using Text property
            book.ActiveSheet.Range["A1"].Text = "Report Saldo Ospiti del reparto " + GetNomeReparto() + " dal " + (dtpInizio.Value ?? DateTime.MinValue).ToString("dd/MM/yyyy") + " al " + (dtpFine.Value ?? DateTime.MinValue).ToString("dd/MM/yyyy");
            book.ActiveSheet.Range["A1"].CellStyle.HorizontalAlignment = ExcelHAlign.HAlignCenter;//set text alignment

            book.SaveAs("ReportOspitiSaldo.xlsx", ExcelSaveType.SaveAsXLS, System.Web.HttpContext.Current.Response, ExcelDownloadType.Open);
            book.Close();
        }
        //esportazione grid in pdf grid per i movimenti
        protected void ReportMovimentiGrid_ServerPdfExporting(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            btnCerca_Click(sender, e);
            PdfExport exp = new PdfExport();
            PdfDocument pdfdocument = new PdfDocument();
            pdfdocument.PageSettings.Orientation = PdfPageOrientation.Landscape;
            ReportMovimentiGrid.Model.Locale = "it-IT{\"EmptyRecord\":\"Nessun risultato trovato\",\"GroupCaptionFormat\":\"{{:headerText}}: {{:key}} - {{:count}}\",\"GroupText\":\" element\"}";
            
            pdfdocument = exp.Export(ReportMovimentiGrid.Model, (IEnumerable)ReportMovimentiGrid.DataSource, "ReportOspitiMovimenti.pdf", false, false, "none", true, true, pdfdocument, "", false);

            RectangleF rect = new RectangleF(0, 0, pdfdocument.PageSettings.Width, 50);

            //create a header pager template
            PdfPageTemplateElement header = new PdfPageTemplateElement(rect);

            Font f = new Font("Helvetica", 10, FontStyle.Bold);

            PdfFont font = new PdfTrueTypeFont(f, true);

            header.Graphics.DrawString("Report Movimenti Ospiti reparto " + GetNomeReparto() + " dal " + (dtpInizio.Value ?? DateTime.MinValue).ToString("dd/MM/yyyy") + " al " + (dtpFine.Value ?? DateTime.MinValue).ToString("dd/MM/yyyy"), font, PdfBrushes.Black, new Point(250, 0)); //Add custom text to the Header
            pdfdocument.Template.Top = header; //Append custom template to the document   

            pdfdocument.Save("ReportOspitiMovimenti.pdf", Response, HttpReadType.Save);
        }
        //esportazione grid in excel per i movimenti
        protected void ReportMovimentiGrid_ServerExcelExporting(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            btnCerca_Click(sender, e);
            ExcelExport exp = new ExcelExport();
            ReportMovimentiGrid.Model.Locale = "it-IT{\"EmptyRecord\":\"Nessun risultato trovato\",\"GroupCaptionFormat\":\"{{:headerText}}: {{:key}} - {{:count}}\",\"GroupText\":\" element\"}";
            IWorkbook book = exp.Export(ReportMovimentiGrid.Model, (IEnumerable)ReportMovimentiGrid.DataSource, "ReportOspitiMovimenti.xlsx", ExcelVersion.Excel2010, false, false, "flat-lime", true);

            book.ActiveSheet.InsertRow(1);
            // Merging the sheet from Range A1 to J1 for adding title space
            book.ActiveSheet.Range["A1:I1"].Merge();

            //Adding the title using Text property
            book.ActiveSheet.Range["A1"].Text = "Report Movimenti Ospiti del reparto " + GetNomeReparto() + " dal " + (dtpInizio.Value ?? DateTime.MinValue).ToString("dd/MM/yyyy") + " al " + (dtpFine.Value ?? DateTime.MinValue).ToString("dd/MM/yyyy");
            book.ActiveSheet.Range["A1"].CellStyle.HorizontalAlignment = ExcelHAlign.HAlignCenter;//set text alignment

            book.SaveAs("ReportOspitiMovimenti.xlsx", ExcelSaveType.SaveAsXLS, System.Web.HttpContext.Current.Response, ExcelDownloadType.Open);
            book.Close();
        }

        //selezione del tipo di report 
        protected void ddTipoReport_ValueSelect(object sender, Syncfusion.JavaScript.Web.DropdownListEventArgs e)
        {
            //ottengo il valore selezionato
            string report = this.ddTipoReport.Value;
            //rendo visibile la grid desiderata
            if (report == Convert.ToString((int)TipoVisualizzazioneGrid.Movimenti))
            {
                this.ReportSaldoGrid.Visible = false;
                this.ReportMovimentiGrid.Visible = true;
            }
            else
            {
                this.ReportSaldoGrid.Visible = true;
                //SetSaldi((string)this.ddReparti.Value, (DateTime)this.dtpInizio.Value, (DateTime)this.dtpFine.Value);
                this.ReportMovimentiGrid.Visible = false;
            }
            //setto campi della grid scelta
            setGridField((string)this.ddReparti.Value, (DateTime)this.dtpInizio.Value, (DateTime)this.dtpFine.Value);
        }

        protected string GetNomeReparto()
        {
            string idReparto = this.ddReparti.Value;
            string reparto = (from t in edm.View_Reparti
                              where t.ID_Reparto == idReparto
                              select t.Des_Reparto).FirstOrDefault();
            return reparto;
        }
    }
}
